﻿"use strict";

app.controller('APITesterController',
    function ($scope, $http, $filter, AppService) {
        $scope.authenInfo = {
            username: 'room',
            authenCode: 'CbqiSPn7vK9oGpHZz8XzTw=='
        };

        $scope.loadItemParams = {
            codeList: '',
            activeOnly: 'Y'
        };

        $scope.itemsParams = {
            code: '',
            name: '',
            categoryCode: '',
            price: 0.00,
            cost: 0.00,
            unitCode: '',
            image: '',
            active: true
        };

        $scope.loadOrderParams = {
            numberList: '',
            includeDetail: false
        }

        $scope.orderParams = {
            orderKey: '',
            orderNumber: '',
            orderDocDate: null,
            ownerCode: '',
            buyerFullName: '',
            buyerTelNumber: '',
            buyerEmail: '',
            shippingAddress: '',
            shippingPostalCode: '',
            orderAmount: 0.00,
            discountRate: 0.00,
            discountAmount: 0.00,
            totalAmount: 0.00,
            vatRate: 0.00,
            vatAmount: 0.00,
            netAmount: 0.00,
            deliveryCode: '',
            cod: false,
            codAmount: 0.00,
            senderFullName: '',
            senderTelNumber: '',
            senderAddress: '',
            senderPostalCode: '',
            detailList: [
                { seq: 1, code: '', quantity: 0, price: 0.00, amount: 0.00 },
                { seq: 2, code: '', quantity: 0, price: 0.00, amount: 0.00 }]
        };

        $scope.orderDetailParams = {
            seq: 0,
            code: '',
            quantity: 1,
            price: 0.00,
            amount: 0.00
        };

        $scope.showAuthenInfo = true;

        $scope.methodSelected = '';
        $scope.methodType = '-';
        $scope.methodUrl = $scope.apiUrl;

        $scope.requestText = '';
        $scope.responseText = '';

        $scope.methodSelectChanged = function () {
            $scope.requestText = '';
            $scope.responseText = '';

            $scope.loadItemParams = {
                codeList: '',
                activeOnly: 'Y'
            };

            $scope.itemsParams = {
                code: '',
                name: '',
                categoryCode: '',
                price: 0.00,
                cost: 0.00,
                unitCode: '',
                image: '',
                active: true
            };

            $scope.loadOrderParams = {
                numberList: '',
                includeDetail: false
            }

            $scope.orderParams = {
                orderKey: '',
                orderNumber: '',
                orderDocDate: null,
                ownerCode: '',
                buyerFullName: '',
                buyerTelNumber: '',
                buyerEmail: '',
                shippingAddress: '',
                shippingPostalCode: '',
                orderAmount: 0.00,
                discountRate: 0.00,
                discountAmount: 0.00,
                totalAmount: 0.00,
                vatRate: 0.00,
                vatAmount: 0.00,
                netAmount: 0.00,
                deliveryCode: '',
                cod: false,
                codAmount: 0.00,
                senderFullName: '',
                senderTelNumber: '',
                senderAddress: '',
                senderPostalCode: '',
                detailList: [
                    { seq: 1, code: '', quantity: 0, price: 0.00, amount: 0.00 },
                    { seq: 2, code: '', quantity: 0, price: 0.00, amount: 0.00}]
            };

            $scope.methodUrl = $scope.apiUrl + $scope.methodSelected;

            if ($scope.methodSelected == 'loadservicepricing'
                || $scope.methodSelected == 'loaditemcategory'
                || $scope.methodSelected == 'loaditemunit') {
                $scope.methodType = 'GET';
                $scope.showAuthenInfo = false;
            }
            else if ($scope.methodSelected == 'loadservicepricingbyuser'
                || $scope.methodSelected == 'loaditemcategorybyuser'
                || $scope.methodSelected == 'loaditemunitbyuser'
                || $scope.methodSelected == 'loaditems' 
                || $scope.methodSelected == 'createitems'
                || $scope.methodSelected == 'updateitems'
                || $scope.methodSelected == 'loadorders'
                || $scope.methodSelected == 'createorders'
                || $scope.methodSelected == 'updateorders'
                || $scope.methodSelected == 'deleteorders') {
                $scope.methodType = 'POST';
                $scope.showAuthenInfo = true;
            }
        }

        $scope.sendRequest = function () {
            if ($scope.methodSelected == 'loadservicepricing'
                || $scope.methodSelected == 'loaditemcategory'
                || $scope.methodSelected == 'loaditemunit') {
                $scope.loadInitialData();
            }
            else if ($scope.methodSelected == 'loadservicepricingbyuser'
                || $scope.methodSelected == 'loaditemcategorybyuser'
                || $scope.methodSelected == 'loaditemunitbyuser') {
                $scope.loadInitialDataByUser();
            }
            else if ($scope.methodSelected == 'loaditems') {
                $scope.loadItems();
            }
            else if ($scope.methodSelected == 'createitems') {
                $scope.createItems();
            }
            else if ($scope.methodSelected == 'updateitems') {
                $scope.updateItems();
            }
            else if ($scope.methodSelected == 'loadorders') {
                $scope.loadOrders();
            }
            else if ($scope.methodSelected == 'createorders') {
                $scope.createOrders();
            }
            else if ($scope.methodSelected == 'updateorders') {
                $scope.updateOrders();
            }
            else if ($scope.methodSelected == 'deleteorders') {
                $scope.deleteOrders();
            }
        }

        //=================Initial Data=================//
        $scope.loadInitialData = function () {
            $scope.requestText = '';
            $scope.responseText = '';

            var url = $scope.methodUrl;
            AppService.get(url)
                .then(
                    function (response) {
                        $scope.responseText = JSON.stringify(response.data);
                    }, function (response) {
                        //console.info('Error>> ', response);
                        var error = {
                            url: response.config.url,
                            method: response.config.method,
                            data: response.data,
                            errorText: response.errorText,
                            statusText: response.statusText,
                            xhrStatus: response.xhrStatus
                        };

                        $scope.responseText = JSON.stringify(error);
                    });
        }

        $scope.loadInitialDataByUser = function () {
            $scope.requestText = '';
            $scope.responseText = '';

            var url = $scope.methodUrl;

            var params = { authenInfo: $scope.authenInfo };
            $scope.requestText = JSON.stringify(params);

            /*AppService.post(url, params)
                .then(
                    function (response) {
                        $scope.responseText = JSON.stringify(response.data);
                    }, function (response) {
                        console.info('Error>> ', response);
                        var error = {
                            url: response.config.url,
                            method: response.config.method,
                            data: response.data,
                            errorText: response.errorText,
                            statusText: response.statusText,
                            xhrStatus: response.xhrStatus
                        };

                        $scope.responseText = JSON.stringify(error);
                    });*/

            $.ajax({
                url: url,
                type: 'post',
                //NOTE: use 'JSON.stringify' for correct Json format.
                data: JSON.stringify(params),
                dataType: "json",
                contentType: 'application/json',
                success: function (response) {
                    $scope.responseText = JSON.stringify(response);

                    setTimeout(function () {
                        $scope.$apply();
                    }, 0.8);
                },
                error: function (xhr, options, error) {
                    console.info('Error>> ', xhr, options, error);

                    var error = {
                        status: xhr.status,
                        statusText: xhr.statusText,
                        
                    };

                    $scope.responseText = JSON.stringify(error);

                    setTimeout(function () {
                        $scope.$apply();
                    }, 0.8);
                }
            });
        }

        //=================Items=================//
        $scope.loadItems = function () {
            $scope.requestText = '';
            $scope.responseText = '';

            var url = $scope.methodUrl;

            var codeList = [];
            if ($scope.loadItemParams.codeList != '') {
                var codeListStr = $scope.loadItemParams.codeList.replace(/\s+/g, '');
                codeList = codeListStr.split(',');
            }

            var activeOnly = null;
            if ($scope.loadItemParams.activeOnly == 'Y') {
                activeOnly = true;
            }
            else if ($scope.loadItemParams.activeOnly == 'N') {
                activeOnly = false;
            }

            var params = {
                authenInfo: $scope.authenInfo,
                codeList: codeList,
                activeOnly: activeOnly
            };
            $scope.requestText = JSON.stringify(params);

            $.ajax({
                url: url,
                type: 'post',
                //NOTE: use 'JSON.stringify' for correct Json format.
                data: JSON.stringify(params),
                dataType: "json",
                contentType: 'application/json',
                success: function (response) {
                    $scope.responseText = JSON.stringify(response);

                    setTimeout(function () {
                        $scope.$apply();
                    }, 0.8);
                },
                error: function (xhr, options, error) {
                    console.info('Error>> ', xhr, options, error);

                    var error = {
                        status: xhr.status,
                        statusText: xhr.statusText,

                    };

                    $scope.responseText = JSON.stringify(error);

                    setTimeout(function () {
                        $scope.$apply();
                    }, 0.8);
                }
            });

            /*AppService.post(url, params)
                .then(
                    function (response) {
                        $scope.responseText = JSON.stringify(response.data);
                    }, function (response) {
                        //console.info('Error>> ', response);
                        var error = {
                            url: response.config.url,
                            method: response.config.method,
                            data: response.data,
                            errorText: response.errorText,
                            statusText: response.statusText,
                            xhrStatus: response.xhrStatus
                        };

                        $scope.responseText = JSON.stringify(error);
                    });*/
        }

        $scope.changeItemsImage = function (file, errFiles) {
            setTimeout(function () {
                $scope.$apply();

                getBase64(file).then(function (data) {
                    $scope.itemsParams.image = data;
                });
            });
        }

        $scope.createItems = function () {
            $scope.requestText = '';
            $scope.responseText = '';

            var url = $scope.methodUrl;

            $scope.itemsParams.price = parseFloat($scope.itemsParams.price);
            $scope.itemsParams.cost = parseFloat($scope.itemsParams.cost);

            var itemList = [];
            itemList.push($scope.itemsParams);

            var params = {
                authenInfo: $scope.authenInfo,
                itemList: itemList
            };
            $scope.requestText = JSON.stringify(params);

            $.ajax({
                url: url,
                type: 'post',
                //NOTE: use 'JSON.stringify' for correct Json format.
                data: JSON.stringify(params),
                dataType: "json",
                contentType: 'application/json',
                success: function (response) {
                    $scope.responseText = JSON.stringify(response);

                    setTimeout(function () {
                        $scope.$apply();
                    }, 0.8);
                },
                error: function (xhr, options, error) {
                    console.info('Error>> ', xhr, options, error);

                    var error = {
                        status: xhr.status,
                        statusText: xhr.statusText,

                    };

                    $scope.responseText = JSON.stringify(error);

                    setTimeout(function () {
                        $scope.$apply();
                    }, 0.8);
                }
            });

            /*AppService.post(url, params)
                .then(
                    function (response) {
                        $scope.responseText = JSON.stringify(response.data);
                    }, function (response) {
                        //console.info('Error>> ', response);
                        var error = {
                            url: response.config.url,
                            method: response.config.method,
                            data: response.data,
                            errorText: response.errorText,
                            statusText: response.statusText,
                            xhrStatus: response.xhrStatus
                        };

                        $scope.responseText = JSON.stringify(error);
                    });*/
        }

        $scope.updateItems = function () {
            $scope.requestText = '';
            $scope.responseText = '';

            var url = $scope.methodUrl;

            $scope.itemsParams.price = parseFloat($scope.itemsParams.price);
            $scope.itemsParams.cost = parseFloat($scope.itemsParams.cost);

            var itemList = [];
            var item = {
                code: $scope.itemsParams.code,
                name: $scope.itemsParams.name,
                price: $scope.itemsParams.price,
                cost: $scope.itemsParams.cost,
                active: $scope.itemsParams.active
            };

            if ($scope.itemsParams.categoryCode != '') {
                item.categoryCode = $scope.itemsParams.categoryCode;
            }

            if ($scope.itemsParams.unitCode != '') {
                item.unitCode = $scope.itemsParams.unitCode;
            }

            if ($scope.itemsParams.image != '') {
                item.image = $scope.itemsParams.image;
            }

            itemList.push(item);

            var params = {
                authenInfo: $scope.authenInfo,
                itemList: itemList
            };
            $scope.requestText = JSON.stringify(params);

            AppService.post(url, params)
                .then(
                    function (response) {
                        $scope.responseText = JSON.stringify(response.data);
                    }, function (response) {
                        //console.info('Error>> ', response);
                        var error = {
                            url: response.config.url,
                            method: response.config.method,
                            data: response.data,
                            errorText: response.errorText,
                            statusText: response.statusText,
                            xhrStatus: response.xhrStatus
                        };

                        $scope.responseText = JSON.stringify(error);
                    });
        }

        //=================Load Orders=================//
        $scope.loadOrders = function () {
            $scope.requestText = '';
            $scope.responseText = '';

            var url = $scope.methodUrl;

            var numberList = [];
            if ($scope.loadOrderParams.numberList != '') {
                var numberListStr = $scope.loadOrderParams.numberList.replace(/\s+/g, '');
                numberList = numberListStr.split(',');
            }

            var params = {
                authenInfo: $scope.authenInfo,
                numberList: numberList,
                includeDetail: $scope.loadOrderParams.includeDetail
            };
            $scope.requestText = JSON.stringify(params);

            AppService.post(url, params)
                .then(
                    function (response) {
                        $scope.responseText = JSON.stringify(response.data);
                    }, function (response) {
                        //console.info('Error>> ', response);
                        var error = {
                            url: response.config.url,
                            method: response.config.method,
                            data: response.data,
                            errorText: response.errorText,
                            statusText: response.statusText,
                            xhrStatus: response.xhrStatus
                        };

                        $scope.responseText = JSON.stringify(error);
                    });
        }

        //=================Create Orders=================//
        $scope.addOrderDetail = function () {
            var maxSeqItem = _.max($scope.orderParams.detailList, function (item) {
                return item.seq;
            });
            console.info('addOrderDetail>> ', maxSeqItem);

            $scope.orderParams.detailList.push({
                seq: (maxSeqItem.seq + 1),
                code: '',
                quantity: 0,
                price: 0.00,
                amount: 0.00,
                operation: 'I',
                operationText: 'Insert'
            });

            setTimeout(function () {
                $scope.$apply();
            }, 0.8);
        }

        $scope.removeOrderDetail = function (item) {
            var seq = item.seq;

            //re-seq
            angular.forEach(_.filter($scope.orderParams.detailList, function (x) { return x.seq > item.seq; }), function (i) {
                i.seq--;
            });

            $scope.orderParams.detailList = _.without($scope.orderParams.detailList, item);
            //calc Summary
            $scope.orderParams.orderAmount = _.reduce(
                _.pluck(_.filter($scope.orderParams.detailList, function (item) {
                    return item.operation != 'D'
                }), 'amount'), function (acc, amount) {
                return acc + amount;
            }, 0);
            $scope.orderParams.totalAmount = $scope.orderParams.orderAmount - $scope.orderParams.discountAmount;

            setTimeout(function () {
                $scope.$apply();
            }, 0.8);
        }

        $scope.orderDetailCalc = function (item) {
            console.info('orderDetailCalc>> ', $scope.orderDetailOriginal);

            var quantity = parseInt(item.quantity);
            var price = parseFloat(item.price);
            
            item.amount = parseFloat((quantity * price).toFixed(2));
            //calc Summary
            $scope.orderParams.orderAmount = _.reduce(
                _.pluck(_.filter($scope.orderParams.detailList, function (item) {
                    return item.operation != 'D'
                }), 'amount'), function (acc, amount) {
                return acc + amount;
            }, 0);
            $scope.orderParams.totalAmount = $scope.orderParams.orderAmount - $scope.orderParams.discountAmount;

            if ($scope.methodSelected == 'updateorders' && item.operation != 'I') {
                item.operation = 'U';
                item.operationText = 'Update';
            }
        }

        $scope.orderDiscountChanged = function () {
            var discountAmount = parseFloat($scope.orderParams.discountAmount);
            $scope.orderParams.totalAmount = $scope.orderParams.orderAmount - discountAmount;
        }

        $scope.createOrders = function () {
            $scope.requestText = '';
            $scope.responseText = '';

            var url = $scope.methodUrl;

            $scope.orderParams.ownerCode = $scope.authenInfo.username;

            $scope.orderParams.discountAmount = parseFloat($scope.orderParams.discountAmount);
            $scope.orderParams.netAmount = $scope.orderParams.totalAmount;

            angular.forEach($scope.orderParams.detailList, function (item) {
                item.quantity = parseInt(item.quantity);
                item.price = parseFloat(item.price);
            });

            var orderList = [];
            orderList.push($scope.orderParams);

            var params = {
                authenInfo: $scope.authenInfo,
                orderList: orderList
            };
            $scope.requestText = JSON.stringify(params);

            AppService.post(url, params)
                .then(
                    function (response) {
                        $scope.responseText = JSON.stringify(response.data);
                    }, function (response) {
                        //console.info('Error>> ', response);
                        var error = {
                            url: response.config.url,
                            method: response.config.method,
                            data: response.data,
                            errorText: response.errorText,
                            statusText: response.statusText,
                            xhrStatus: response.xhrStatus
                        };

                        $scope.responseText = JSON.stringify(error);
                    });
        }

        //=================Update Orders=================//
        $scope.orderDetailOriginal = [];
        $scope.loadAndFillOrders = function () {
            if ($scope.orderParams.orderNumber != '') {
                var url = $scope.apiUrl + 'loadorders';

                var numberList = [];

                $scope.orderParams.orderNumber.replace(/\s+/g, '');
                numberList.push($scope.orderParams.orderNumber);

                var params = {
                    authenInfo: $scope.authenInfo,
                    numberList: numberList,
                    includeDetail: true
                };
                $scope.requestText = JSON.stringify(params);

                AppService.post(url, params)
                    .then(
                        function (response) {
                            $scope.orderDetailOriginal = [];

                            $scope.responseText = JSON.stringify(response.data);

                            console.info('orderList>> ', response.data.orderList);

                            var orderList = response.data.orderList;
                            if (orderList != null && orderList.length > 0) {
                                var order = orderList[0];

                                $scope.orderParams = {
                                    orderKey: order.orderKey,
                                    orderNumber: order.orderNumber,
                                    orderDocDate: order.orderDocDate.substring(0, 10),
                                    ownerCode: order.ownerCode,
                                    buyerFullName: order.buyerFullName,
                                    buyerTelNumber: order.buyerTelNumber,
                                    buyerEmail: order.buyerEmail,
                                    shippingAddress: order.shippingAddress,
                                    shippingPostalCode: order.shippingPostalCode,
                                    orderAmount: order.orderAmount,
                                    discountRate: order.discountRate,
                                    discountAmount: order.discountAmount,
                                    totalAmount: order.totalAmount,
                                    vatRate: order.vatRate,
                                    vatAmount: order.vatAmount,
                                    netAmount: order.netAmount,
                                    deliveryCode: order.deliveryCode,
                                    cod: order.cod,
                                    codAmount: order.codAmount,
                                    senderFullName: order.senderFullName,
                                    senderTelNumber: order.senderTelNumber,
                                    senderAddress: order.senderAddress,
                                    senderPostalCode: order.senderPostalCode,
                                    detailList: order.detailList
                                };

                                angular.forEach($scope.orderParams.detailList, function (item) {
                                    item.operation = '';
                                    item.operationText = 'N/A';

                                    $scope.orderDetailOriginal.push({
                                        seq: item.seq,
                                        code: item.code,
                                        price: item.price,
                                        quantity: item.quantity,
                                        amount: item.amount
                                    });
                                });

                                setTimeout(function () {
                                    $scope.$apply();
                                }, 0.8);
                            }

                        }, function (response) {
                            //console.info('Error>> ', response);
                            var error = {
                                url: response.config.url,
                                method: response.config.method,
                                data: response.data,
                                errorText: response.errorText,
                                statusText: response.statusText,
                                xhrStatus: response.xhrStatus
                            };

                            $scope.responseText = JSON.stringify(error);
                        });
            }
        }

        $scope.deleteOrderDetail = function (item) {
            item.operation = 'D';
            item.operationText = 'Delete';

            //calc Summary
            $scope.orderParams.orderAmount = _.reduce(
                _.pluck(_.filter($scope.orderParams.detailList, function (item) {
                    return item.operation != 'D'
                }), 'amount'), function (acc, amount) {
                    return acc + amount;
                }, 0);
            $scope.orderParams.totalAmount = $scope.orderParams.orderAmount - $scope.orderParams.discountAmount;
        }

        $scope.excludeOrderDetail = function (item) {
            item.operation = 'EX';
            item.operationText = 'Excluded';
        }

        $scope.includeOrderDetail = function (item) {
            item.operation = '';
            item.operationText = 'N/A';
        }

        $scope.recoverOrderDetail = function (item) {
            if (item.operation == 'U') {
                var originalItem = _.find($scope.orderDetailOriginal, function (i) {
                    return i.seq == item.seq && i.code == item.code;
                });

                if (originalItem && originalItem != undefined && originalItem != -Infinity) {
                    item.seq = originalItem.seq;
                    item.code = originalItem.code;
                    item.price = originalItem.price;
                    item.quantity = originalItem.quantity;
                    item.amount = originalItem.amount;
                    item.operation = '';
                    item.operationText = 'N/A'

                    //calc Summary
                    $scope.orderParams.orderAmount = _.reduce(
                        _.pluck(_.filter($scope.orderParams.detailList, function (item) {
                            return item.operation != 'D'
                        }), 'amount'), function (acc, amount) {
                            return acc + amount;
                        }, 0);
                    $scope.orderParams.totalAmount = $scope.orderParams.orderAmount - $scope.orderParams.discountAmount;

                    setTimeout(function () {
                        $scope.$apply();
                    }, 0.8);
                }
            }
            else {
                item.operation = '';
                item.operationText = 'N/A';

                //calc Summary
                $scope.orderParams.orderAmount = _.reduce(
                    _.pluck(_.filter($scope.orderParams.detailList, function (item) {
                        return item.operation != 'D'
                    }), 'amount'), function (acc, amount) {
                        return acc + amount;
                    }, 0);
                $scope.orderParams.totalAmount = $scope.orderParams.orderAmount - $scope.orderParams.discountAmount;
            }
        }

        $scope.updateOrders = function () {
            $scope.requestText = '';
            $scope.responseText = '';

            var url = $scope.methodUrl;

            $scope.orderParams.ownerCode = $scope.authenInfo.username;

            $scope.orderParams.discountAmount = parseFloat($scope.orderParams.discountAmount);
            $scope.orderParams.netAmount = $scope.orderParams.totalAmount;

            var updateOrderParams = {
                orderKey: $scope.orderParams.orderKey,
                orderNumber: $scope.orderParams.orderNumber,
                ownerCode: $scope.orderParams.ownerCode,
                deliveryCode: $scope.orderParams.deliveryCode,
                cod: $scope.orderParams.cod,
                codAmount: $scope.orderParams.codAmount,
                orderAmount: $scope.orderParams.orderAmount,
                orderAmount: $scope.orderParams.discountAmount,
                orderAmount: $scope.orderParams.totalAmount,
                orderAmount: $scope.orderParams.netAmount,
                detailList: []
            };

            if ($scope.orderParams.orderDocDate != '') {
                updateOrderParams.orderDocDate = $scope.orderParams.orderDocDate;
            }

            if ($scope.orderParams.buyerFullName != '') {
                updateOrderParams.buyerFullName = $scope.orderParams.buyerFullName;
            }

            if ($scope.orderParams.buyerTelNumber != '') {
                updateOrderParams.buyerTelNumber = $scope.orderParams.buyerTelNumber;
            }

            if ($scope.orderParams.shippingAddress != '') {
                updateOrderParams.shippingAddress = $scope.orderParams.shippingAddress;
            }

            if ($scope.orderParams.shippingPostalCode != '') {
                updateOrderParams.shippingPostalCode = $scope.orderParams.shippingPostalCode;
            }

            if ($scope.orderParams.senderFullName != '') {
                updateOrderParams.senderFullName = $scope.orderParams.senderFullName;
            }

            if ($scope.orderParams.senderTelNumber != '') {
                updateOrderParams.senderTelNumber = $scope.orderParams.senderTelNumber;
            }

            if ($scope.orderParams.senderAddress != '') {
                updateOrderParams.senderAddress = $scope.orderParams.senderAddress;
            }

            if ($scope.orderParams.senderPostalCode != '') {
                updateOrderParams.senderPostalCode = $scope.orderParams.senderPostalCode;
            }

            angular.forEach($scope.orderParams.detailList, function (item) {
                item.quantity = parseInt(item.quantity);
                item.price = parseFloat(item.price);

                updateOrderParams.detailList.push({
                    seq: item.seq,
                    code: item.code,
                    price: item.price,
                    quantity: item.quantity,
                    amount: item.amount,
                    operation: item.operation
                });
            });

            var orderList = [];
            orderList.push(updateOrderParams);

            var params = {
                authenInfo: $scope.authenInfo,
                orderList: orderList
            };
            $scope.requestText = JSON.stringify(params);

            AppService.post(url, params)
                .then(
                    function (response) {
                        $scope.responseText = JSON.stringify(response.data);
                    }, function (response) {
                        //console.info('Error>> ', response);
                        var error = {
                            url: response.config.url,
                            method: response.config.method,
                            data: response.data,
                            errorText: response.errorText,
                            statusText: response.statusText,
                            xhrStatus: response.xhrStatus
                        };

                        $scope.responseText = JSON.stringify(error);
                    });
        }

        //=================Delete Orders=================//
        $scope.deleteOrders = function () {
            $scope.requestText = '';
            $scope.responseText = '';

            var url = $scope.methodUrl;

            var orderList = [];
            orderList.push({
                orderKey: $scope.orderParams.orderKey,
                orderNumber: $scope.orderParams.orderNumber
            });

            var params = {
                authenInfo: $scope.authenInfo,
                orderList: orderList
            };
            $scope.requestText = JSON.stringify(params);

            AppService.post(url, params)
                .then(
                    function (response) {
                        $scope.responseText = JSON.stringify(response.data);
                    }, function (response) {
                        //console.info('Error>> ', response);
                        var error = {
                            url: response.config.url,
                            method: response.config.method,
                            data: response.data,
                            errorText: response.errorText,
                            statusText: response.statusText,
                            xhrStatus: response.xhrStatus
                        };

                        $scope.responseText = JSON.stringify(error);
                    });
        }

        //***Utilities***//
        function getBase64(file) {
            return new Promise((resolve, reject) => {
                const reader = new FileReader();
                reader.readAsDataURL(file);
                reader.onload = () => resolve(reader.result);
                reader.onerror = error => reject(error);
            });
        }
    });
