app.service("AppService", ['$http', '$q',
    function ($http, $q) {
        return ({
            handleError: handleError,
            handleSuccess: handleSuccess,
            get: get,
            post: post
        });

        function handleError(response) {
            console.info('>> handleError', response);

            if (response.data != null && response.data.remark) {
                response.errorText = response.data.remark;
                //TODO:
                //response.messageStackTrace = response.data.message_stack_trace;
            } else if (response.status = -1) {
                response.errorText = "Connection refused.";
                //} else if (!angular.isObject(response.data) || !response.data.Remark) {
                //    response.Remark = (response.statusText != null) ? response.statusText : response.message;
                //}
                return ($q.reject(response));
            }
        }

        function handleSuccess(response) {
            //console.info(">> handleSuccess", response);

            if (response.data != null) {
                response.result = response.data.result;
                response.remark = response.data.remark;
                response.stackTrace = response.data.stackTrace;

                if (response.result == "ERROR") {
                    console.info('>> resultError', response);
                    if (response.remark.toLowerCase().indexOf('session expired') >= 0) {
                        AppService.redirect('Error/Index/99');
                    }

                    response.errorText = response.remark;
                }

                return (response);
            }
            else {
                return ($q.reject(response));
            }
        }

        function get(url, data) {
            //blockUI.start();
            var request = $http({
                method: "GET",
                url: url,
                headers: {
                    "Cache-Control": "max-age=360",
                    "Strict-Transport-Security": "max-age=31536000; includeSubDomains"
                },
                params: data
            });
            //blockUI.stop();
            return (request.then(handleSuccess, handleError));
        }

        function post(url, data) {
            //***Angular Post*****//
            var post = $http({
                method: 'POST',
                url: url,
                headers: {
                    "Cache-Control": "max-age=360",
                    "Strict-Transport-Security": "max-age=31536000; includeSubDomains",
                    'Content-Type': undefined
                },

                transformRequest: function (data) {
                    var formData = new FormData();
                    if (data) {
                        var keys = Object.keys(data);

                        for (var i = 0; i < keys.length; i++) {
                            var key = keys[i];
                            formData.append(key, angular.toJson(data[key]));
                        }
                    }
                    return formData;
                },
                data: data
            });

            return (post.then(handleSuccess, handleError));
        }
    }
]);
